searchNodes=[{"doc":"Plug for authentication using token signature verification.OptionDescriptionDefault valuelimit_timetime in hours168 h (1 w)secretSecret keyemptyhandlerError handler functionResuelveAuth.Sample.AuthHandlerExample # En el archivo router.ex defmodule MyApi.Router do # Using 10 hours as limit and default error handler @options [secret: &quot;my-secret-key&quot;, limit_time: 10] use MyApi, :router pipeline :auth do plug ResuelveAuth.AuthPlug, @options end scope &quot;/v1&quot;, MyApi do pipe_through([:auth]) .. post(&quot;/users/&quot;, UserController, :create) end end","ref":"ResuelveAuth.AuthPlug.html","title":"ResuelveAuth.AuthPlug","type":"module"},{"doc":"Token generation and validation module.","ref":"ResuelveAuth.Helpers.TokenHelper.html","title":"ResuelveAuth.Helpers.TokenHelper","type":"module"},{"doc":"Returns token generated from a map in the following format SECURE_BASE64_JSON.SIGNATURE_HMAC_SHA_256_BASE16Examples iex&gt; alias ResuelveAuth.TokenData iex&gt; timestamp = 1572656155135 iex&gt; data = %TokenData{ meta: nil, role: &quot;service&quot;, service: &quot;my-api&quot;, session: nil, timestamp: timestamp } iex&gt; options = [secret: &quot;secret&quot;, limit_time: 4] iex&gt; alias ResuelveAuth.Helpers.TokenHelper iex&gt; token = TokenHelper.create_token(data, options) &quot;eyJ0aW1lc3RhbXAiOjE1NzI2NTYxNTUxMzUsInNlc3Npb24iOm51bGwsInNlcnZpY2UiOiJteS1hcGkiLCJyb2xlIjoic2VydmljZSIsIm1ldGEiOm51bGx9.1E1FA5A03B62DB5E0E5C5627D578E4ABBD1E83EFBFF72907428D0C95DC491394&quot; iex&gt; String.length(token) 185","ref":"ResuelveAuth.Helpers.TokenHelper.html#create_token/2","title":"ResuelveAuth.Helpers.TokenHelper.create_token/2","type":"function"},{"doc":"Extrae la fecha de un mapa en el formato {:ok, %{}} esperando que sea un formato de unix y convertirlo a fecha.Ejemplos: iex&gt; timestamp = 1583797948623 iex&gt; data = %{&quot;timestamp&quot; =&gt; timestamp, &quot;otra_llave&quot; =&gt; &quot;algo&quot;} iex&gt; parameter = {:ok, data} iex&gt; {:ok, data} = ResuelveAuth.Helpers.TokenHelper.extract(parameter) iex&gt; Map.keys(data) [&quot;otra_llave&quot;, &quot;time&quot;, &quot;timestamp&quot;]","ref":"ResuelveAuth.Helpers.TokenHelper.html#extract/1","title":"ResuelveAuth.Helpers.TokenHelper.extract/1","type":"function"},{"doc":"Identify if the time is less than the time limitEjemplo: iex&gt; ResuelveAuth.Helpers.TokenHelper.is_expired(4, 5) false iex&gt; ResuelveAuth.Helpers.TokenHelper.is_expired(4, 4) false iex&gt; ResuelveAuth.Helpers.TokenHelper.is_expired(5, 4) true","ref":"ResuelveAuth.Helpers.TokenHelper.html#is_expired/2","title":"ResuelveAuth.Helpers.TokenHelper.is_expired/2","type":"function"},{"doc":"Get the data from a valid token.Examples iex&gt; alias ResuelveAuth.TokenData iex&gt; timestamp = DateTime.to_unix(DateTime.utc_now(), :millisecond) iex&gt; data = %TokenData{ meta: nil, role: &quot;service&quot;, service: &quot;my-api&quot;, session: nil, timestamp: timestamp } iex&gt; options = [secret: &quot;secret&quot;, limit_time: 4] iex&gt; alias ResuelveAuth.Helpers.TokenHelper iex&gt; token = TokenHelper.create_token(data, options) iex&gt; {:ok, result} = TokenHelper.verify_token(token, options) iex&gt; result[&quot;timestamp&quot;] == data.timestamp true iex&gt; result[&quot;service&quot;] == data.service true","ref":"ResuelveAuth.Helpers.TokenHelper.html#verify_token/2","title":"ResuelveAuth.Helpers.TokenHelper.verify_token/2","type":"function"},{"doc":"Example of implementing an error handler.","ref":"ResuelveAuth.Sample.AuthHandler.html","title":"ResuelveAuth.Sample.AuthHandler","type":"module"},{"doc":"Handles errors that the plug can respond to","ref":"ResuelveAuth.Sample.AuthHandler.html#errors/2","title":"ResuelveAuth.Sample.AuthHandler.errors/2","type":"function"},{"doc":"","ref":"ResuelveAuth.Sample.AuthHandler.html#reason/1","title":"ResuelveAuth.Sample.AuthHandler.reason/1","type":"function"},{"doc":"Structure that defines the elements of a token.","ref":"ResuelveAuth.TokenData.html","title":"ResuelveAuth.TokenData","type":"module"},{"doc":"Convert token to valid data or return an error.","ref":"ResuelveAuth.TokenData.html#cast/2","title":"ResuelveAuth.TokenData.cast/2","type":"function"},{"doc":"Encapsulates the functions related to the date. If using a time library is required, it should be added here the desired functionality. In the project you should only find calls to the Calendar module to facilitate code maintenance.","ref":"ResuelveAuth.Utils.Calendar.html","title":"ResuelveAuth.Utils.Calendar","type":"module"},{"doc":"Returns the difference between two dates in unix format.Example iex&gt; {ayer, ahora} = {1577646287000, 1577733231563} iex&gt; {:ok, first} = DateTime.from_unix(ayer, :millisecond) iex&gt; {:ok, second} = DateTime.from_unix(ahora, :millisecond) iex&gt; ResuelveAuth.Utils.Calendar.diff(first, second) -24 iex&gt; {ayer, ahora} = {1577646287000, 1577733231563} iex&gt; {:ok, first} = DateTime.from_unix(ayer, :millisecond) iex&gt; {:ok, second} = DateTime.from_unix(ahora, :millisecond) iex&gt; ResuelveAuth.Utils.Calendar.diff(second, first) 24","ref":"ResuelveAuth.Utils.Calendar.html#diff/2","title":"ResuelveAuth.Utils.Calendar.diff/2","type":"function"},{"doc":"Converts the given Unix time to DateTime. iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; {:ok, %DateTime{} = date} = Calendar.from_unix(1572617244) iex&gt; DateTime.to_unix(date) 1572617 iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; Calendar.from_unix(1724.0) {:error, :invalid_unix_time} iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; Calendar.from_unix(&quot;algo&quot;) {:error, :invalid_unix_time}","ref":"ResuelveAuth.Utils.Calendar.html#from_unix/1","title":"ResuelveAuth.Utils.Calendar.from_unix/1","type":"function"},{"doc":"Identifies if the date sent as Unix time is passed. In case of sending a value that is not an integer, it returns true by default.Examples iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; unix_time = 1572617244 iex&gt; Calendar.is_past?(unix_time) true iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; unix_time = 4128685709000 iex&gt; Calendar.is_past?(unix_time) false iex&gt; alias ResuelveAuth.Utils.Calendar iex&gt; Calendar.is_past?(&quot;2100-02-29T12:30:30+00:00&quot;) true","ref":"ResuelveAuth.Utils.Calendar.html#is_past?/1","title":"ResuelveAuth.Utils.Calendar.is_past?/1","type":"function"},{"doc":"Returns the current date in unix time.Example &gt; ResuelveAuth.Utils.Calendar.unix_now() 1577733231563","ref":"ResuelveAuth.Utils.Calendar.html#unix_now/0","title":"ResuelveAuth.Utils.Calendar.unix_now/0","type":"function"},{"doc":"Contains encoding, decoding, encryption, and decryption logic.","ref":"ResuelveAuth.Utils.Secret.html","title":"ResuelveAuth.Utils.Secret","type":"module"},{"doc":"","ref":"ResuelveAuth.Utils.Secret.html#cypher/1","title":"ResuelveAuth.Utils.Secret.cypher/1","type":"function"},{"doc":"","ref":"ResuelveAuth.Utils.Secret.html#cypher/2","title":"ResuelveAuth.Utils.Secret.cypher/2","type":"function"},{"doc":"","ref":"ResuelveAuth.Utils.Secret.html#cypher/3","title":"ResuelveAuth.Utils.Secret.cypher/3","type":"function"},{"doc":"","ref":"ResuelveAuth.Utils.Secret.html#decode/1","title":"ResuelveAuth.Utils.Secret.decode/1","type":"function"},{"doc":"","ref":"ResuelveAuth.Utils.Secret.html#decode64/1","title":"ResuelveAuth.Utils.Secret.decode64/1","type":"function"},{"doc":"","ref":"ResuelveAuth.Utils.Secret.html#encode/1","title":"ResuelveAuth.Utils.Secret.encode/1","type":"function"},{"doc":"","ref":"ResuelveAuth.Utils.Secret.html#encode64/1","title":"ResuelveAuth.Utils.Secret.encode64/1","type":"function"},{"doc":"Identify if the tuple of the signed string is valid according to the sent token.Example iex&gt; alias ResuelveAuth.Utils.Secret iex&gt; data = %{valid: &quot;datos&quot;} iex&gt; Secret.equivalent?(data, &quot;datos&quot;) true iex&gt; alias ResuelveAuth.Utils.Secret iex&gt; data = {:error, &quot;error message&quot;} iex&gt; Secret.equivalent?(data, &quot;data&quot;) {:error, &quot;error message&quot;}","ref":"ResuelveAuth.Utils.Secret.html#equivalent?/2","title":"ResuelveAuth.Utils.Secret.equivalent?/2","type":"function"},{"doc":"Sign the information with a seed (secret) by first going through a coding process.","ref":"ResuelveAuth.Utils.Secret.html#sign/2","title":"ResuelveAuth.Utils.Secret.sign/2","type":"function"},{"doc":"!Issues]issues-shield [ResuelveAuthPlug to validate signed request.","ref":"readme.html","title":"ResuelveAuth","type":"extras"},{"doc":"UsageRequerimentsSecret generationCrear token y validarloErrorsError handlerContributors","ref":"readme.html#content","title":"ResuelveAuth - CONTENT","type":"extras"},{"doc":"def deps do [{:resuelve_auth, &quot;~&gt; 1.4.3&quot;}] endAdd the plugin to a pipeline, following the guides to creating libraries in Elixir, the options are configured and can be sent to the plugin.pipeline :api_auth do ... options = [ secret: &quot;secret&quot;, limit_time: 4, handler: MyApp.AuthHandler ] plug ResuelveAuth.AuthPlug, options end","ref":"readme.html#usage","title":"ResuelveAuth - Usage","type":"extras"},{"doc":"Cause the library require OTP 21.0 you must need to use:elixir 1.7.2erlang 21.0 I recommend using asdf as CLI tool that can manage multiple language runtime versions. So, you can use the rigth versions with:$ asdf install","ref":"readme.html#requeriments","title":"ResuelveAuth - Requeriments","type":"extras"},{"doc":"When you use Phoenix you can create a new secret with:$&gt; mix phx.gen.secret 32 TICxDq3wquPi49UuMfA4PjnWpz1PqnB1 $&gt; mix phx.gen.secret 64 b9sq3yGrwWKXxpNfx3+a8hEaRa3S5QWMiRg+gPpbzc54ZpjVaqDYD3DRbPuYx621 Another way to create a secret is:$&gt; date +%s | sha256sum | base64 | head -c 32 ; echo MGYwM2M1Njk1MGIxYjcyOGY3OTc0ZDk0 $&gt; date +%s | sha256sum | base64 | head -c 64 ; echo ZGZhMzZhOWQyZTViOWQxNWIyY2NlMGExMDVhMzQ1ZGNkODA1YWUxNmRmMWRjMGZi And the last if you wish to use openssl$&gt; openssl rand -base64 32 //ZE5siYI04Bp/2JtFq3uJOpS4XXChADe8b9RHenzFY= $&gt; openssl rand -base64 64 qlTw8sjiavcPAKIHJbO/zOUqLCS99zmyerjnoRc6FumLIc/Q9K9TjitS4JmTFh5r 3ULjJAMfkouTR1OUV4LZ4Q==","ref":"readme.html#secret-generation","title":"ResuelveAuth - Secret generation","type":"extras"},{"doc":"When you need to use the token struct, %TokenData{} is the option. So, you can define your struct as:%TokenData{ service: service, role: &quot;service&quot;, meta: &quot;metadata&quot;, timestamp: 1593731494361 }As you can see the timestamp field requires a Unix time number. Then timestamp could be created with:DateTime.to_unix(DateTime.utc_now(), :millisecond)And your struct looks like:%TokenData{ service: &quot;my-api&quot;, role: &quot;admin&quot;, meta: &quot;metadata&quot;, timestamp: DateTime.to_unix(DateTime.utc_now(), :millisecond) }When you create the token the function require some options.OptionDescriptionDefault valuelimit_timetime in hours168 h (1 w)secretSecret keyemptyhandlerError handler functionResuelveAuth.Sample.AuthHandleriex&gt; alias ResuelveAuth.TokenData iex&gt; alias ResuelveAuth.Helpers.TokenHelper iex&gt; time = DateTime.to_unix(DateTime.utc_now(), :millisecond) iex&gt; token_data = %TokenData{ service: &quot;my-api&quot;, role: &quot;admin&quot;, meta: &quot;metadata&quot;, timestamp: time } iex&gt; options = [secret: &quot;super-secret-key&quot;, limit_time: 4] iex&gt; token = TokenHelper.create_token(token_data, options) &quot;eyJ0aW1lc3RhbXAiOjE1OTM3MzQ0MzQ4ODEsInNlc3Npb24iOm51bGwsInNlcnZpY2UiOiJteS1hcGkiLCJyb2xlIjoiYWRtaW4iLCJtZXRhIjoibWV0YWRhdGEifQ==.9AAEBDB040BFB22160B4628EC45D69C3546C0775398D7B03C113C5BDDEC3A74B&quot; After the token was created you can use it in your requests and validate with the follow method:iex&gt; options = [secret: &quot;super-secret-key&quot;, limit_time: 4] iex&gt; {:ok, result} = TokenHelper.verify_token(token, options) {:ok, %{ &quot;meta&quot; =&gt; &quot;metadata&quot;, &quot;role&quot; =&gt; &quot;admin&quot;, &quot;service&quot; =&gt; &quot;my-api&quot;, &quot;session&quot; =&gt; nil, &quot;time&quot; =&gt; ~U[2020-07-03 00:00:34.881Z], &quot;timestamp&quot; =&gt; 1593734434881 }}If the token is invalid, you may see an error like this:** (MatchError) no match of right hand side value: {:error, :wrong_format}","ref":"readme.html#create-new-token-data","title":"ResuelveAuth - Create new token data","type":"extras"},{"doc":"The following are the errors returned by the plug:{:error, :expired}{:error, :unauthorized}{:error, :wrong_format}Error handlerMaybe you want to handle each error message or improve some details in the response. Below is an example of how to customize error handling.defmodule App.MyErrorHandler do def errors(conn, reason) do # Error handler logic end end iex&gt; options = [secret: &quot;super-secret-key&quot;, limit_time: 4, handler: Module.Handler] iex&gt; token = TokenHelper.verify_token(token, options)verify_token function should not call directly, this function is used as a sample. Here is an example of the ResuelveAuth.Sample.AuthHandler module. @spec errors(map, String.t()) :: any def errors(conn, message) do Logger.error(fn -&gt; &quot;Invalid token: \#{inspect(message)}&quot; end) detail = reason(message) response = Poison.encode!(%{data: nil, errors: %{detail: detail}}) conn |&gt; put_resp_content_type(&quot;application/json&quot;) |&gt; send_resp(:unauthorized, response) |&gt; halt end","ref":"readme.html#errors","title":"ResuelveAuth - Errors","type":"extras"},{"doc":"This is the list of contributors who have participated in this project.","ref":"readme.html#contributors","title":"ResuelveAuth - Contributors","type":"extras"}]